stages:
  - prepare
  - build
  - test
  - centralize
  - deploy

# prepare
prepare:initialization:
  stage: prepare
  tags:
    - ci-auctus
    - u180464B-4 
  script:
    - echo ci | sudo -S mv /usr/local/lib/libexpat.so.1 /usr/local/lib/libexpat.so.1.bak && echo $?;echo $?;
  allow_failure: true
  
  
# builds  
build:release:u180464b:
  stage: build
  tags:
    - ci-auctus
    - u180464B-4 
  script:
    - mkdir -p ci_ws/src/franka_control
    - shopt -s extglob
    - mv !(ci_ws) ci_ws/src/franka_control
    - cd ci_ws
    - catkin config --init --extend=/home/ci/soft/franka_ros_ws/devel --cmake-args -DFranka_DIR:PATH=/home/ci/soft/libfranka/build
    - source /home/ci/soft/franka_ros_ws/devel/setup.bash
    - catkin build -DCMAKE_BUILD_TYPE=Release -DCMAKE_CXX_FLAGS=--coverage
    
build:debug:u180464b:
  stage: build
  tags:
    - ci-auctus
    - u180464B-4 
  script:
    - mkdir -p ci_ws/src/franka_control
    - shopt -s extglob
    - mv !(ci_ws) ci_ws/src/franka_control
    - cd ci_ws
    - catkin config --init --extend=/home/ci/soft/franka_ros_ws/devel --cmake-args -DFranka_DIR:PATH=/home/ci/soft/libfranka/build
    - source /home/ci/soft/franka_ros_ws/devel/setup.bash
    - catkin build -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_FLAGS=--coverage
  artifacts:
    paths:
      - ci_ws/src
      - ci_ws/build
      - ci_ws/devel  
    
# analysis
analysis:coverage:
  stage: test
  tags:
    - ci-auctus
    - u180464B-4 
  script:
    - mkdir -p analysis/gcov
    - source ci_ws/devel/setup.bash
    - ls
    - timeout 5s roslaunch franka_control franka_control.launch robot_ip:=192.16.0.2 || echo exit code $?
    - gcovr --filter="/home/*" --root="$PWD" --xml-pretty --object-directory="$PWD/ci_ws/build" --output="analysis/coverage.xml"
  dependencies:
    - build:debug:u180464b
  artifacts:
    paths:
      - analysis
      - ci_ws/devel
      - ci_ws/src      
  allow_failure: true
  
analysis:static:
  stage: test
  tags:
    - ci-auctus
    - u180464B-4 
  script:
    - mkdir analysis
    - cppcheck --enable=all --suppress=missingIncludeSystem --xml ci_ws/src/franka_control &> analysis/cppcheckOutput.xml
    - rats --xml --warning=3 ci_ws/src > analysis/ratsOutput.xml
  dependencies:
    - build:debug:u180464b
  artifacts:
    paths:
      - analysis

sonarqube:
  stage: centralize
  dependencies:
    - analysis:coverage
    - analysis:static
  tags:
    - ci-auctus
    - u180464B-4 
  script:
    - export PATH=$PATH:/home/ci/soft/sonar-scanner-4.2.0.1873-linux/bin
    - sonar-scanner
    
# documentation deployment
pages:
  stage: deploy
  tags:
    - ci-auctus
    - u180464b-4
  script:
    - doxygen Doxyfile
    - mv html/ public/
  artifacts:
    paths:
      - public
  dependencies:
    - sonarqube
  only:
    - master

